from tensorflow.python.platform import gfile
from tensorflow import GraphDef
import tensorflow as tf

""" File I/O """
def read_graphdef_from_frozen_pb_file(frozen_pb_filename):
    # Reads a tensorflow GraphDef from a frozen graph's protobuf.
    tf_graphdef = GraphDef()
    with gfile.FastGFile(frozen_pb_filename, "rb") as frozen_pb:
        tf_graphdef.ParseFromString(frozen_pb.read())
    return tf_graphdef

def write_graphdef_to_frozen_pb_file(tf_graphdef, frozen_pb_filename):
    # Write to output protobuf
    with open(frozen_pb_filename, "wb") as ofile:
        ofile.write(tf_graphdef.SerializeToString())

def write_graphdef_to_tensorboard_logdir(tf_graphdef, tensorboard_logdir_name):
    try:
        writer = tf.summary.FileWriter(logdir=tensorboard_logdir_name, graph_def=tf_graphdef)
        writer.close()
    except:
        pass
