from tensorflow import NodeDef

""" Node Utility Functions """
# FIXME: Is there a better way to do this?
def create_node(name, op=None, attr=[]):
    # attr is of the form [("TF Field Name", "TF Attr Value Type", "Value")]
    new_node = NodeDef()
    new_node.name = name
    new_node.op = op if op else name
    for field_name, field_type, value in attr:
        # Once we have the most nested attribute, set it.
        if "list" in field_type:
            # Special case for lists - we expect value to also be a list.
            active_attr = new_node.attr[field_name]
            # Support for nested attributes.
            for attr_layer in field_type.split('.'):
                active_attr = getattr(active_attr, attr_layer)
            active_attr.extend(value)
        else:
            # Otherwise, set it as a normal attribute.
            setattr(new_node.attr[field_name], field_type, value)
    return new_node
