from collections import defaultdict

""" Graph Utility Functions """
def get_names_from_nodes(node_list):
    # Creates a set of names from a given list of nodes.
    return set([node.name for node in node_list])

def get_output_map(tf_graphdef):
    # Given a tf_graphdef, returns a dictionary of {node name: set(output node names)}
    output_map = defaultdict(set)
    for node in tf_graphdef.node:
        for input_name in node.input:
            output_map[input_name].add(node.name)
    return output_map

def get_node_names_map(tf_graphdef):
    # A mapping of node names to nodes in the GraphDef
    return {node.name: node for node in tf_graphdef.node}
